"use strict";

var _lodash = require("lodash");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var isArray = Array.isArray;

module.exports = function joinArrays() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      customizeArray = _ref.customizeArray,
      customizeObject = _ref.customizeObject,
      key = _ref.key;

  return function _joinArrays(a, b, k) {
    var newKey = key ? "".concat(key, ".").concat(k) : k;

    if ((0, _lodash.isFunction)(a) && (0, _lodash.isFunction)(b)) {
      return function () {
        return _joinArrays(a.apply(void 0, arguments), b.apply(void 0, arguments), k);
      };
    }

    if (isArray(a) && isArray(b)) {
      var customResult = customizeArray && customizeArray(a, b, newKey);
      return customResult || [].concat(_toConsumableArray(a), _toConsumableArray(b));
    }

    if ((0, _lodash.isPlainObject)(a) && (0, _lodash.isPlainObject)(b)) {
      var _customResult = customizeObject && customizeObject(a, b, newKey);

      return _customResult || (0, _lodash.mergeWith)({}, a, b, joinArrays({
        customizeArray: customizeArray,
        customizeObject: customizeObject,
        key: newKey
      }));
    }

    if ((0, _lodash.isPlainObject)(b)) {
      return (0, _lodash.cloneDeep)(b);
    }

    return b;
  };
};